import 'color.dart';

class GeneratorFormatter {
  String _formatColor(ColorSwatchProperty color) {
    // Class name to be used
    final String colorClass = 'Color';

    // Color variable name
    String colorName = color.primary!.name;

    // Top of color
    String top = '  static const $colorClass $colorName = '
        '$colorClass(${color.primary!.hex});\n';

    // process swatches
    String swatches = '';
    color.swatches.forEach((ColorProperty element) {
      swatches += '  static const $colorClass $colorName${element.index} = '
          '$colorClass(${element.hex});\n';
    });

    return top + swatches;
  }

  String formatBody(List<ColorSwatchProperty> swatches) {
    String body = '';

    for (int i = 0; i < swatches.length; i++) {
      body += _formatColor(swatches[i]);

      if (i < swatches.length - 1) {
        body += '\n';
      }
    }

    return body;
  }

  String formatClass(String className, String body) {
    String importStatement = "import 'dart:ui';\n\n";
    importStatement += "// @autogenerate DO NOT EDIT!!!\n";

    String classTop = 'class $className {\n';
    String classBottom = '}\n';

    return importStatement + classTop + body + classBottom;
  }
}
